<?php
/*
= LuxCal calendar tools =

 Copyright 2009-2014 LuxSoft - www.LuxSoft.eu

*/

//heredocs
$actT = <<<TXT
<p>These tools will help you to . . .
<ul>
<li>Test if your LuxCal calendar environment is configured correctly</li>
<li>Add one or more new calendars to the current database</li>
<li>Set one of the calendars as the default calendar</li>
<li>Delete one or more existing calendars from the current database</li>
<li>Replicate data from one or more tables in a backup file to one or more 
existing calendars</li>
<li>Replicate the settings from the default calendar to one or more existing 
calendars</li>
<li>Back up calendar data for one or more calendars</li>
</ul>
TXT;

$act0T = <<<TXT
<h5>Test configuration</h5>
<p>This action can be used to run a number of tests to see if your LuxCal 
calendar environment is configured correctly for the calendar to run properly. 
</p>
<p>The following tests can be executed:</p>
<ul>
<li>File permission: to see if the calendar has write access to the 
<kbd>root</kbd> folder and the <kbd>files</kbd> folder</li>
<li>PHP session: to test if PHP sessions are enabled in the PHP installation and 
are working correctly</li>
<li>Browser cookies: to check if cookies are enabled in your your browser </li>
</ul>
TXT;

$act1T = <<<TXT
<h5>Create new calendars</h5>
<p>This action will add one or more new calendars to the database. This may be 
useful if you want to run several independent calendars with one LuxCal 
installation.</p>
<br>
<p><b>Calendar ID(s) / Title(s)</b></p>
<p><b>Current calendars:</b> The list of currently installed calendars.</p>
<p><b>New calendars:</b> To add new calendars, specify pairs of calendar IDs and 
titles in the format calendar ID = calendar Title, e.g. home = My Home Calendar. 
Each calendar ID = title pair must be specified on a separate line.</p>
<p>A calendar ID is a text string of max. 20 lowercase alphanumeric characters 
and the title is a normal text string of maximum 100 characters. For each ID = 
title pair a set of calendar tables will be created in the database, with the ID 
prepended to the table names.</p>
<p>After the installation, the calendar ID cal be used to select a specific 
calendar. For instance to select the calendar "home" the following calendar URL 
should be used: http://www.mysite.xxx/calendar/<b>?cal=home</b>.</p>
<br>
<p><b>calendar email (optional)</b></p>
<p>The calendar email address is used in email reports, reminders, etc. If no 
email address is specified, the administrator email address will be taken 
instead.</p>
<br>
<p><b>administrator name</b>, <b>email</b> and <b>password</b></p>
<p>These fields must be completed and should be remembered. They will be 
required later to log in to the new calendars.</p>
TXT;

$act2T = <<<TXT
<h5>Set default calendar</h5>
<p>This action will set one of the calendars as the default calendar.</p>
<p>When multiple calendars are installed in the database, a specific calendar 
can be launched by adding "?cal=calID" to the URL, where calID is the ID of the 
calendar to be launched. When this string is not added to the URL, the default 
calendar will be launched</p>
<p>The ID of the default calendar will be saved in the lcconfig.php file.</p>
<br>
<p><b>Select calendar(s)</b></p>
<p>Select the calendar that should become the default.</p>
TXT;

$act3T = <<<TXT
<h5>Delete calendars</h5>
<p>This action will definitively delete one or more calendars from the database.
</p>
<p><b>THIS ACTION IS IRREVERSIBLE!</b></p>
<br>
<p><b>Select calendar(s)</b></p>
<p>Select the calendars to delete.</p>
TXT;

$act4T = <<<TXT
<h5>Replicate data and / or settings from file to calendar tables</h5>
<p>First create a backup of the source calendar. This can be done via this tool 
or in the source calendar via the admin's Database page. The backup file is 
created in the 'files' folder and should be renamed into 
<kbd>replicate.sql</kbd></p>
<br>
<p><b>Select calendar(s)</b></p>
<p>Select the destination calendar(s) from the list of calendars present in the 
database.</p>
<br>
<p><b>Select table(s)</b></p>
<p>Specify for which database tables data should be copied from the backup file.
</p>
<p>You <b>MUST</b> read the following:</p>
<ul>
<li><b>Events table:</b> The events from the backup file will be added to the 
events table, so existing events will not be deleted in the destination tables.
</li>
<li><b>Categories table:</b> The data from the category table in the backup file 
will be copied to the categories table of the destination calendar(s).<br> 
<b>Existing categories in the destination calendars will be lost!</b></li>
<li><b>Users table:</b> The data from the users table in the backup file will be 
copied to the users table of the destination calendar(s).<br> 
<b>Existing user accounts in the destination calendars will be lost!</b></li>
<li><b>Settings table:</b> The data from the settings table in the backup file 
will be copied to the settings table of the destination calendar(s).<br> 
<b>The settings in the destination calendar will be overwritten by the source 
settings,</b> except for the calendar title, URL and email address; they are 
calendar specific and will remain unchanged.</li>
</ul>
<br>
<p><b>IMPORTANT NOTE: If after the copying has completed the category IDs in 
the events table do not match with a category ID in the categories table, 
the events will not be visible in the calendar and can not be accessed anymore!
</b></p>
TXT;

$act5T = <<<TXT
<h5>Replicate settings from default calendars</h5>
<p>This action will copy the settings from the default calendar to one or more 
selected calendars.</p>
<p><b>The settings in the destination calendar will be overwritten by the source 
settings,</b> except for the calendar title, URL and email address; they are 
calendar specific and will remain unchanged.</p>
<br>
<p><b>Select calendar(s)</b></p>
<p>Select the destination calendars.</p>
TXT;

$act6T = <<<TXT
<h5>Back up calendars</h5>
<p>This action will back up the structure and contents of the database tables of 
one or more calendars in the database.</p>
<p>Per selected calendar a backup file will be created in the 'files' folder on 
the server, with the following file name:</p>
<p><b>calID-backup-yyyymmdd-hhmmss.sql</b></p>
<p>Where calID is the calendar ID, yyyymmdd is the current date and hhmmss is 
the current time.</p>
<p>The backup files are in .sql format and . . .</p>
<ul>
<li>can be imported directly into a MySQL database tool on your server (e.g. 
phpMyAdmin) to completely re-create the calendar tables and their contents</li>
<li>can be used by the 'Replicate data and / or settings from file to calendar 
tables' option of this tool to restore or copy the contents of the tables to the 
same or one or more other calendars. For details select this option on the main 
menu</li>
</ul>
<br>
<p><b>Select calendar(s)</b></p>
Select the calendars to back up.
TXT;

date_default_timezone_set(@date_default_timezone_get()); //set time zone

//sanity check
if (version_compare(PHP_VERSION, '5.1.0') < 0) { //check PHP version
	exit('<br><br><b>Wrong PHP version</b><br><br>You need version 5.1.0 or higher<br>Your current version is: '.PHP_VERSION);
}
foreach ($_REQUEST as $key => $value) { if (is_string($value)) $_REQUEST[$key] = htmlspecialchars(strip_tags(trim($value)),ENT_QUOTES,'UTF-8'); }

require './common/toolbox.php';
require './common/toolboxx.php';

//initialize
$dbHost = $dbUnam = $dbPwrd = $dbName = $calendars = '';
$calTitDefault = 'My Web Calendar';
$calUrlDefault = 'http://'.$_SERVER['SERVER_NAME'].rtrim(dirname($_SERVER['PHP_SELF']),'/').'/';
$calEmlDefault = 'admin@calendar.xxx';

//init menu selections
$allTabs = array('1'=>'events', '2'=>'categories', '3'=>'users', '4'=>'settings');
$back = !empty($_POST['back']) ? true : false; //back
$action = (!empty($_POST['action']) and !$back) ? $_POST['action'] : ''; //selected action
$start = !empty($_POST['start']) ? true : false; //start action
$selTsts = !empty($_POST['tst']) ? $_POST['tst'] : array(); //array with selected tests
$selCals = !empty($_POST['cal']) ? $_POST['cal'] : array(); //array with selected calendars
$selTabs = !empty($_POST['tab']) ? $_POST['tab'] : array(); //array with selectedtables
$newCals = !empty($_POST['calDef']) ? $_POST['calDef'] : ''; //cal ID = title pairs
$defCal = !empty($_POST['defCal']) ? $_POST['defCal'] : ''; //default calendar
$calEml = !empty($_POST['calEml']) ? $_POST['calEml'] : ''; //cal email
$adName = !empty($_POST['adName']) ? $_POST['adName'] : ''; //admin name
$adMail = !empty($_POST['adMail']) ? $_POST['adMail'] : ''; //admin email
$adPwrd = !empty($_POST['adPwrd']) ? $_POST['adPwrd'] : ''; //admin password

//start PHP session (needed to be able to unset session variables later)
session_start();

//for session test
if (!$start) { //save session variables
	$_SESSION['lcSess1'] = 42; //create var 1
	$_SESSION['lcSess2'] = 'Einstein'; //create var 2
} else { //get session values
	$lcSess1 = (isset($_SESSION['lcSess1'])) ? $_SESSION['lcSess1'] : '';
	$lcSess2 = (isset($_SESSION['lcSess2'])) ? $_SESSION['lcSess2'] : '';
}

//for cookie test
if (!$start) { //bake cookie
	setcookie('lcTest', serialize(array(43, 'Newton')), time()+86400); //expire in 1 day
} else {
	//get cookie values and bake new cookie
	list($lcCook1,$lcCook2) = @unserialize(str_replace('\\','',($_COOKIE['lcTest']))); 
	setcookie('lcTest', serialize(array(43, 'Newton')), time()+86400); //update time to 1 day
}

//connect to db server and select database
$vMySql = ''; //init
if (file_exists('./lcconfig.php')) {
	include("./lcconfig.php"); //get database credentials
	$dbLink = mysql_connect ($dbHost,$dbUnam,$dbPwrd);
	if ($dbLink !== false) {
		$selected = mysql_select_db($dbName,$dbLink);
		if ($selected) {
			$rSet = dbQuery("SHOW TABLES LIKE '%settings'"); //get table IDs
			$calIDs = array();
			if ($dbPfix) { $calIDs[] = $dbPfix; }
			while ($row = mysql_fetch_row($rSet)) {
				if (substr($row[0],-9,1) == '_') { //has prefix_
					if (substr($row[0],0,-9) != $dbPfix) { $calIDs[] = substr($row[0],0,-9); }
				}
			}
			$rSet = mysql_query("SELECT VERSION() as ve"); //get db version
			$obj = mysql_fetch_object($rSet);
			$vMySql = $obj->ve;
		}
	}
}
if (empty($vMySql)) { exit('<br><br>No calendar installed.<br>First run the <kbd>installxxx.php</kbd> script'); }

//get version info
$vInfo = 'PHP: '.PHP_VERSION.' - MySQL: '.(!empty($vMySql) ? $vMySql : '--');
?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title>LuxCal Calendar Tools</title>
<meta name="description" content="LuxCal web calendar - a LuxSoft product">
<meta name="keywords" content="LuxSoft, LuxCal, LuxCal web calendar">
<meta name="author" content="Roel Buining">
<meta name="robots" content="nofollow">
<link rel="icon" href="lcal.ico"/>
<style type="text/css">
* { padding:0; margin:0; }
body {font:11px arial, sans-serif; background:#E0E0E0; color:#2B3856; cursor:default;}
a {text-decoration:none; cursor:pointer;}
header {padding:0 1%;}
h3 {margin:8px 0; font-size:14pt;}
h4 {margin:6px 0; font-size:12pt;}
h5 {margin:2px 0; font-size:11pt;}
input, textarea {font:11px arial, sans-serif;}
input[type="text"] { width:240px; }
input[type="radio"], input[type="checkbox"], label {cursor:pointer;}
input[type="submit"], input[type="button"] {margin:0 15px; cursor:pointer;}
input[disabled] {cursor:default;}
textarea {width:100%; height:120px;}
ul, ol {margin:0 20px;}
li {margin:5px 0;}
.flag {color:#FF3300;}
.navBar {
	width:98%;
	padding:0 1%;
	background:#AAAAFF;
	text-align:right;
	border-top:1px solid #808080;
	border-bottom:1px solid #808080;
	line-height:20px;
	vertical-align:middle;
}
.endBar {
	position:absolute; left:0; bottom:10px;
	width:98%;
	padding:0 1%;
	background:#AAAAFF;
	text-align:right;
	border-top:1px solid #808080;
	border-bottom:1px solid #808080;
	font-size:0.8em;
}
div.content {
	position:absolute; left:0; top:110px; right:0px; bottom:100px;
	padding:0 20px;
	overflow:auto;
}
.aside {width:45%; border:1px solid #808080; background:#FFFFFF; margin-top:80px; padding:15px; float:right; text-align:justify;}
.centerBox {display:table; margin:auto;}
.form {width:360px; border:1px solid #808080; background:#FFFFFF; padding:5px 15px;}
.resultBox {width:380px; border:1px solid #808080; background:#FFFFFF; padding:5px; text-align:justify;}
.bLine {position:absolute; left:0; bottom:50px; width:98%; text-align:center;}
.hilite {margin:10px 0; background:#F0A070;}
.mark {color:#AA0000;}
.greyout {color:#808080; cursor:default;}
.center {text-align:center;}
.footLB {font:italic bold 1.1em arial,sans-serif; }
.footLR {font:italic bold 1.1em arial,sans-serif; color:#AA0066;}
</style>
<script>
function $I(el) { return document.getElementById(el); }
function $C(el) { return document.getElementsByClassName(el); }
function $N(el) { return document.getElementsByName(el); }

function checkA(boxName) { //check "all" of N checkboxes
	var chBox0 = $I(boxName+'0');
	var chBoxes = $N(boxName+'[]');
	check0 = chBox0.checked ? true : false;
	for (var i=(chBoxes.length-1);i >= 0;i--) {
		chBoxes[i].checked = check0;
	}
}

function check1(boxName,checked) { //check 1 of N checkboxes
	var chBoxes = $N(boxName);
	for (var i=(chBoxes.length-1);i >= 0;i--) {
		chBoxes[i].checked = false;
	}
	checked.checked = true;
}

function checkN(boxName) { //check any of N checkboxes
	var chBoxes = $N(boxName+'[]');
	var check0 = true;
	for (var i=(chBoxes.length-1);i >= 0;i--) {
		if (!chBoxes[i].checked) { check0 = false; }
	}
	$I(boxName+'0').checked = check0;
}

function submit() {
	$I('form').submit();
}

function valForm() {
	var ok = true;
	if ($I('action').value == 'delete') {
		ok = confirm("When deleting calendars, the data in\nthe concerned calendars will be lost.\n\nTHIS ACTION IS IRREVERSIBLE!\n\n\t\tPlease confirm");
	}
	return ok;
}
</script>
</head>

<body>
<header>
<h4>LuxCal Event Calendar</h4>
</header>
<div class="navBar"><?php echo $vInfo; ?></div>
<div class="content">
<?php
if ($start) { //validate menu selections
	$errMsg = array();
	if ($action == 'test') {
		if (empty($selTsts)) { $errMsg[] = 'No tests selected'; }
	}
	if ($action == 'create') {
		$regEx = "~^([a-z0-9]{1,20}\s*=\s*[^<>?%$@{}\\^=]{1,100}[\r\n]+)+$~";
		if (!preg_match($regEx,$newCals."\n")) { $errMsg[] = "No or invalid calendar ID = title pair(s)"; }
		if (empty($adName)) { $errMsg[] = 'No admin name'; }
		if (!empty($calEml) and !preg_match($rxEmailX,$calEml)) { $errMsg[] = 'Invalid calendar email address'; }
		if (!preg_match($rxEmailX,$adMail)) { $errMsg[] = 'No or invalid admin email address'; }
		if (empty($adPwrd)) { $errMsg[] = 'No admin password'; }
	}
	if ($action == 'set') {
		if (empty($defCal)) { $errMsg[] = 'No calendar selected'; }
	}
	if (strpos(' delete copy replicate backup',$action)) {
		if (empty($selCals)) { $errMsg[] = 'No calendar selected'; }
	}
	if ($action == 'copy') {
		if (empty($selTabs)) { $errMsg[] = 'No tables selected'; }
	}
}

if (!$start or $errMsg) {
	echo '<aside class="aside">'."\n";
	echo '<h4>Instructions</h4>'."\n";
	switch ($action) { //show instructions
		case '': echo $actT; break;
		case 'test': echo $act0T; break;
		case 'create': echo $act1T; break;
		case 'set': echo $act2T; break;
		case 'delete': echo $act3T; break;
		case 'copy': echo $act4T; break;
		case 'replicate': echo $act5T; break;
		case 'backup': echo $act6T; break;
	}
	echo "</aside>\n";
}
echo '<div class="centerBox">'."\n";
echo '<h3 class="center">LuxCal Calendar Tools</h3><br><br>'."\n";
if ($start and !$errMsg) {
	//Perform action
	switch ($action) {
	case 'test': //Process Test configuration
		$resMsg = "<h4>Test configuration successful</h4>\n";
		foreach ($selTsts as $v) {
			switch ($v) {
			case 'perm':
				//check file permissions
				if (file_put_contents('./lctest.dat','LuxCal') === false) { //write test file
					$errMsg[] = "Error: Unable to write to the calendar's 'root' folder<br>Check file permissions on your server";
				} else {
					unlink('./lctest.dat'); //delete test file
					$resMsg .= "<p><b>Writing to the calendar's 'root' folder successful</b></p>\n";
				}
				if (file_put_contents('./files/lctest.dat','LuxCal') === false) { //write test file
					$errMsg[] = "Error: Unable to write to the calendar's 'files' folder<br>Check file permissions on your server";
				} else {
					unlink('./files/lctest.dat'); //delete test file
					$resMsg .= "<p><b>Writing to the calendar's 'files' folder successful</b></p>\n";
				}
			break;
			case 'sess':
				if ($lcSess1 != 42 or $lcSess2 != 'Einstein') { //test session vars
					$errMsg[] = "PHP sessions disabled or not working";
				} else {
					$resMsg .= "<p><b>PHP sessions enabled and working correctly</b></p>\n";
				}
			break;
			case 'cook':
				if ((empty($lcCook1) or $lcCook1 != 43) or (empty($lcCook2) or $lcCook2 != 'Newton')) { //test cookies
					$errMsg = "Browser cookies disabled or not working";
				} else {
					$resMsg .= "<p><b>Browser cookies enabled and working correctly</b></p>\n";
				}
			}
		}
	break;
	
	case 'create': //Process Create calendars
		$nrCals = $nrPres = 0;
		$calArray = preg_split('~[\r\n]+~m',$newCals);
		$count = 0;
		foreach ($calArray as $newCal) { //create calendar
			list($calID,$calTitle) = explode('=',$newCal);
			$calID = trim($calID);
			$calTitle = trim($calTitle);
			if ($count == 0) { $topCal = $calID; $count++;}
			//if not present, create tables
			$tabEvt = createDbTable('events',$calID);
			if (!$tabEvt) { $errMsg[] = "Error: Problem creating table {$calID}_events"; break; }
			$tabCat = createDbTable('categories',$calID);
			if (!$tabCat) { $errMsg[] = "Error: Problem creating table {$calID}_categories"; break; }
			$tabUsr = createDbTable('users',$calID);
			if (!$tabUsr) { $errMsg[] = "Error: Problem creating table {$calID}_users"; break; }
			$tabSet = createDbTable('settings',$calID);
			if (!$tabSet) { $errMsg[] = "Error: Problem creating table {$calID}_settings"; break; }
			//insert initial data in cat, user and settings tables
			$catSaved = initCats($calID);
			if (!$catSaved) {
				$errMsg[] = "Error: Problem writing to database table {$calID}_categories"; break;
			}
			$adPwMd5 = md5($adPwrd);
			$usrSaved = initUsers($calID,$adName,$adMail,$adPwMd5);
			if (!$usrSaved) {
				$errMsg[] = "Error: Problem writing to database table {$calID}_users"; break;
			}
			$setSaved = true; //init
			if ($tabSet != '2') { //insert default settings
				$dbSet = array();
				$dbSet['calendarTitle'] = $calTitle;
				$dbSet['calendarUrl'] = $calUrlDefault.'?cal='.$calID;
				$dbSet['calendarEmail'] = (!empty($calEml) ? $calEml : $adMail);
				checkSettings($dbSet);
				$setSaved = saveSettings($calID,$dbSet,true);
				if (!$setSaved) {
					$errMsg[] = "Error: Unable to save settings to database table {$calID}_settings"; break;
				}
			}
			if ($tabEvt == 2 or $tabCat == 2 or $tabUsr == 2 or $tabSet == 2) { $nrPres++; } 
			$nrCals++;
		}
		//create session data table
		$result = createDbTable('sessdata');
		if (!$result) { $errMsg[] = "Error: Problem creating table {$calID}_sessdata"; }

		if (!$dbPfix) { //no calendar
			$dbPfix = $topCal; //set new default calendar
			$lcconfig = preg_replace('~\$dbPfix\s*=\s*["\'][a-z0-9]{0,20}["\']~',"\$dbPfix='{$dbPfix}'",file_get_contents("./lcconfig.php"));
			file_put_contents('lcconfig.php',$lcconfig);
		}

		if (empty($errMsg)) { //display result
			$resMsg = "<h4>Calendar creation successful</h4>\n";
			if ($nrPres) {
				$resMsg .= "<p><b>{$nrPres} calendar(s) allready present</b></p>\n";
			}
			$resMsg .= "<p><b>".($nrCals-$nrPres)." calendar(s) created</b></p>\n";
		}
	break;

	case 'set': //process Set default calendar
		$dbPfix = $defCal; //set new default calendar
		$lcconfig = preg_replace('~\$dbPfix\s*=\s*["\'][a-z0-9]{0,20}["\']~',"\$dbPfix='{$dbPfix}'",file_get_contents("./lcconfig.php"));
		file_put_contents('lcconfig.php',$lcconfig);
		$resMsg = "<h4>Default calendar set successfully</h4>\n<p><b>Default calendar set to '{$dbPfix}' in lcconfig.php</b></p>\n";
	break;

	case 'delete': //process Delete calendars action
		$nrCals = $newDefault = 0;
		$calsLeft = array_diff($calIDs,$selCals);
		foreach ($selCals as $calID) { //process calendars
			$result = dbQuery("DROP TABLE IF EXISTS {$calID}_categories, {$calID}_events, {$calID}_users, {$calID}_settings"); //drop all table
			if (!$result) { $errMsg[] = "Error deleting calendar {$calID}"; break; }
			$nrCals++;
			if ($calID == $dbPfix) { $newDefault++; } //default calendar deleted
		}
		if ($newDefault) {
			$dbPfix = !$calsLeft ? '' : reset($calsLeft); //set new default calendar, if any
			$lcconfig = preg_replace('~\$dbPfix\s*=\s*["\'][a-z0-9]{0,20}["\']~',"\$dbPfix='{$dbPfix}'",file_get_contents("./lcconfig.php"));
			file_put_contents('lcconfig.php',$lcconfig);
		}
		if (empty($errMsg)) { //display result
			$resMsg = "<h4>Deletion successful</h4>\n<p><b>{$nrCals} calendar(s) deleted</b></p>\n";
			if ($newDefault) {
				$resMsg .= "<br><p><b>default calendar set to '{$dbPfix}' in lcconfig.php</b></p>\n";
			}
		}
	break;

	case 'copy': //process Replicate data and / or settings from file
		if (!is_readable('./files/replicate.sql')) {
			$errMsg[] = "File 'replicate.sql' is not found in the 'files' folder.";
			break;
		}
		//Read SQL queries from replicate.sql
		$sqlQueries = file('./files/replicate.sql', FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
		foreach ($sqlQueries as $value) {
			if (!preg_match('~^\s+INSERT\s+INTO\s+[a-z\d]{0,20}_(categories|events|settings|users)\s+VALUES\s*\(.+\);~i',trim($value))) {
				unset($sqlQueries[$value]);
			}
		}
		$nrCals = 0;
		foreach ($selCals as $calID) { //Process SQL INSERT queries for each selected calendar
			$nrC = $nrE = $nrS = $nrU = 0; //init counters
			//prepare tables for INSERT
			if (in_array('categories',$selTabs)) { //categories table selected
				$result = dbQuery("TRUNCATE TABLE {$calID}_categories"); //empty table, reset auto-increment keys
			}
			if (in_array('users',$selTabs)) { //users table selected
				$result = dbQuery("TRUNCATE TABLE {$calID}_users"); //empty table, reset auto-increment keys
			}
			if (in_array('settings',$selTabs)) { //settings table selected
				$result = dbQuery("DELETE FROM {$calID}_settings WHERE name NOT LIKE 'calendar%'"); //empty table, except calendar values
				//if not present in settings, insert default calendar title, URL and email
				$rSet = dbQuery("SELECT value FROM {$calID}_settings WHERE name = 'calendarTitle'");
				if (mysql_num_rows($rSet) == 0) { //not present
					$result = dbQuery("INSERT INTO {$calID}_settings VALUES ('calendarTitle','".mysql_real_escape_string($calTitDefault.' - '.$calID)."','Calendar title displayed in the top bar')");
					if (!$result) { $errMsg[] = "Error inserting default calendar title in {$calID}_settings"; break; }
				}
				$rSet = dbQuery("SELECT value FROM {$calID}_settings WHERE name = 'calendarUrl'");
				if (mysql_num_rows($rSet) == 0) { //not present
					$result = dbQuery("INSERT INTO {$calID}_settings VALUES ('calendarUrl','".mysql_real_escape_string($calUrlDefault.'?cal='.$calID)."','Calendar link (URL)')");
					if (!$result) { $errMsg[] = "Error inserting default calendar URL in {$calID}_settings"; break; }
				}
				$rSet = dbQuery("SELECT value FROM {$calID}_settings WHERE name = 'calendarEmail'");
				if (mysql_num_rows($rSet) == 0) { //not present
					$result = dbQuery("INSERT INTO {$calID}_settings VALUES ('calendarEmail','".mysql_real_escape_string($calEmlDefault)."','Sender in and receiver of email notifications')");
					if (!$result) { $errMsg[] = "Error inserting default calendar email in {$calID}_settings"; break; }
				}
			}
			$result = true;
			foreach ($sqlQueries as $query) { //process INSERT queries
				$matches = array(); //init
				if (preg_match('~^(INSERT\s+INTO\s+)([a-z\d]{0,20}_)(categories|events|settings|users)(\s+VALUES\s*\(.+\))~i',trim($query),$matches)) {
					if (in_array($matches[3],$selTabs)) { //table selected
						switch ($matches[3]) {
						case 'categories':
							$result = dbQuery($matches[1].$calID.'_'.$matches[3].$matches[4]);
							if (!$result) { break; }
							$nrC++;
							break;
						case 'events':
							$result = dbQuery($matches[1].$calID.'_'.$matches[3].preg_replace('~VALUES\("\d+?"~','VALUES("NULL"',$matches[4])); //events are added!
							if (!$result) { break; }
							$nrE++;
							break;
						case 'settings':
							if (!preg_match('~VALUES\("calendar~',$matches[4])) { //don't copy calendar title, URL , email
								$result = dbQuery($matches[1].$calID.'_'.$matches[3].$matches[4]);
								if (!$result) { break; }
								$nrS++;
							}
							break;
						case 'users': $nrU++;
							$result = dbQuery($matches[1].$calID.'_'.$matches[3].$matches[4]);
							if (!$result) { break; }
						}
					}
				}
			}
			if (!$result) { $errMsg[] = "Error inserting data in table {$calID}_{$matches[3]}"; break; }
			$nrCals++;
		}
		if (empty($errMsg)) { //display result
			$resMsg = "<h4>Copying tables successful</h4>\n".
				"<p><b>In {$nrCals} calendar(s):</b></p>\n".
				"<div>- Number of categories inserted: {$nrC}</div>\n".
				"<div>- Number of events inserted: {$nrE}</div>\n".
				"<div>- Number of settings inserted: {$nrS}</div>\n".
				"<div>- Number of users inserted: {$nrU}</div>\n";
		}
	break;

	case 'replicate': //process Replicate settings from default calendars
		$calID = $dbPfix;
		$dbSet = getSettings();
		$nrCals = 0;
		foreach ($selCals as $calID) { //process calendars
			$setSaved = saveSettings($calID,$dbSet,false);
			if (!$setSaved) {
				$errMsg[] = "Error: Unable to save settings to calendar {$calID}"; break;
			}
			$nrCals++;
		}
		if (empty($errMsg)) { //display result
			$resMsg = "<h4>Duplicating settings from default calendar successful</h4>\n".
				"<p><b>Settings replicated to {$nrCals} calendar(s)</b></p>\n";
		}
	break;

	case 'backup': //process Backup calendars
		$nrCals = 0;
		foreach ($selCals as $calID) { //process calendars
			//get table names
			$tableSet = dbQuery("SHOW TABLES LIKE '{$calID}_%'");
			if (!$tableSet) {
				$errMsg[] = "No tables found in calendar {$calID}"; break;
			} else { //back up tables
				$sqlFile = '';
				while ($table = mysql_fetch_row($tableSet)) {
					$rSet = dbQuery("SELECT * FROM {$table[0]}");
					$nrFields = mysql_num_fields($rSet);
					$sqlFile .= 'DROP TABLE IF EXISTS '.$table[0].';';
					$createTableCode = mysql_fetch_row(dbQuery("SHOW CREATE TABLE {$table[0]}"));
					$sqlFile .= "\n\n{$createTableCode[1]};\n\n";
					for ($i = 0; $i < $nrFields; $i++) {
						while($row = mysql_fetch_row($rSet)) {
							$sqlFile .= "INSERT INTO {$table[0]} VALUES(";
							for($j=0; $j<$nrFields; $j++) {
								$row[$j] = preg_replace("%\n%","\\n",$row[$j]);
								$sqlFile .= isset($row[$j]) ? '"'.addslashes($row[$j]).'"' : '""';
								if ($j < ($nrFields-1)) { $sqlFile .= ','; } 
							}
							$sqlFile .= ");\n";
						}
					}
					$sqlFile .="\n";
				}
				//save .sql backup file
				$fName = './files/'.$calID.'-backup-'.date('Ymd-His').'.sql';
				if (file_put_contents($fName,$sqlFile) === false) { 
					$errMsg[] = "Could not save backup file {$fName}"; break;
				}
			}
			$nrCals++;
		}
		if (empty($errMsg)) { //display result
			$resMsg = "<h4>Back up successful</h4>\n<p><b>{$nrCals} calendar(s) backed up</b></p>\n";
		}
	break;
	}
	
	session_unset(); //force retrieve of settings and selection of default calendar

	//display Action result
	echo '<div class="resultBox">'."\n";
	if (!empty($errMsg)) {
		echo "<h4>The following errors occurred</h4>\n";
		foreach ($errMsg as $msg) {
			echo "<p class='hilite center'>= {$msg} =</p>\n";
		}
	} else {
		echo $resMsg;
	}
	echo "<br><br>\n<div class=\"center\">\n";
	echo "<input type='button' onclick=\"window.location='index.php'\" value='start default calendar'/>\n";
	echo "<input type='button' onclick=\"window.location='{$_SERVER['PHP_SELF']}'\" value='back to tools'/>\n";
	echo "</div>\n";
	echo "</div>\n";
} else {
	//Add calendar titles from database to calendar IDs
	$calendars = array();
	$curCals = '';
	foreach ($calIDs as $v) {
		$rSet = dbQuery("SELECT value FROM {$v}_settings WHERE name = 'calendarTitle'");
		$row = mysql_fetch_assoc($rSet);
		$calendars[$v] = stripslashes($row['value']); //save title
		$curCals .= "&nbsp;&nbsp;{$v} = {$calendars[$v]}";
		$curCals .= ($v == $dbPfix) ? ' <span class="mark">(default)</span><br>' : '<br>'; //is default cal
	}

	if (empty($errMsg)) {
		if ($back or !$action) {
			echo '<p class="center">Choose an action.</p>'."\n";
		} else {
			echo '<p class="center">Complete the form and click the '.ucfirst($action).' button.</p>'."\n";
		}
	} else {
		foreach ($errMsg as $msg) {
			echo "<p class='hilite center'>= {$msg} =</p>\n";
		}
	}
	echo "<br>\n";
	echo '<form class="form" id="form" action= "'.htmlentities($_SERVER['PHP_SELF']).'" method="post">'."\n";
	echo '<h4 class="hilite center">= read instructions =</h4>'."\n";
	if ($back or !$action) {
		$disabled = !$calIDs ? ' disabled' : '';
		$greyout = $disabled ? " class='greyout'" : '';
		echo "<h5>Action</h5>\n";
		echo "<input type='radio' id='act0' onclick='submit()' name='action' value='test'>";
		echo "<label for='act0'> Test configuration</label><br>\n";
		echo "<input type='radio' id='act1' onclick='submit()' name='action' value='create'>";
		echo "<label for='act1'> Create new calendars</label><br>\n";
		echo "<input type='radio' id='act2' onclick='submit()' name='action' value='set'{$disabled}>";
		echo "<label for='act2'{$greyout}> Set default calendar</label><br>\n";
		echo "<input type='radio' id='act3' onclick='submit()' name='action' value='delete'{$disabled}>";
		echo "<label for='act3'{$greyout}> Delete calendars</label><br>\n";
		echo "<input type='radio' id='act4' onclick='submit()' name='action' value='copy'{$disabled}>";
		echo "<label for='act4'{$greyout}> Replicate data and / or settings from file</label><br>\n";
		echo "<input type='radio' id='act5' onclick='submit()' name='action' value='replicate'{$disabled}>";
		echo "<label for='act5'{$greyout}> Replicate settings from default calendar</label><br>\n";
		echo "<input type='radio' id='act6' onclick='submit()' name='action' value='backup'{$disabled}>";
		echo "<label for='act6'{$greyout}> Back up calendars</label><br>\n";
		echo "<br>\n";
		echo "<p><b>Currently installed calendar(s):</b></p>\n";
		if ($curCals) {
			echo $curCals;
			echo "<br><br>\n<div class=\"center\">\n";
			echo "<input type='button' onclick=\"window.location='index.php'\" value='start default calendar'/>\n";
			echo "</div>\n";
		} else {
		 echo 'none';
		}
	} else {
		echo "<input type='hidden' id='action' name='action' value='{$action}'/>\n";
	}
	if ($action == 'test') { echo "<h5>Test configuration</h5>\n"; }
	if ($action == 'create') { echo "<h5>Create new calendars</h5>\n"; }
	if ($action == 'set') { echo "<h5>Set default calendar</h5>\n"; }
	if ($action == 'delete') { echo "<h5>Delete calendars</h5>\n"; }
	if ($action == 'copy') { echo "<h5>Replicate data and / or settings from file</h5>\n"; }
	if ($action == 'replicate') { echo "<h5>Replicate settings from default calendar</h5>\n"; }
	if ($action == 'backup') { echo "<h5>Back up calendars</h5>\n"; }
	echo "<br>\n";
	if ($action and strpos(' test',$action)) {
		echo "<p><b>Select tests:</b> </p>\n";
		$checked = !empty($_POST['tstAll']) ? " checked='checked'" : '';
		echo "<input type='checkbox' id='tst0' name='tstAll' value='all' onclick=\"checkA('tst');\"{$checked}><label for='tst0'> All tests</label><br>\n";
		$checked = (!empty($_POST['tst']) and in_array('perm',$_POST['tst'])) ? " checked='checked'" : '';
		echo "<input type='checkbox' id='tst1' name='tst[]' value='perm' onclick=\"checkN('tst');\"{$checked}><label for='tst1'> File permissions</label><br>\n";
		$checked = (!empty($_POST['tst']) and in_array('sess',$_POST['tst'])) ? " checked='checked'" : '';
		echo "<input type='checkbox' id='tst2' name='tst[]' value='sess' onclick=\"checkN('tst');\"{$checked}><label for='tst2'> PHP sessions</label><br>\n";
		$checked = (!empty($_POST['tst']) and in_array('cook',$_POST['tst'])) ? " checked='checked'" : '';
		echo "<input type='checkbox' id='tst3' name='tst[]' value='cook' onclick=\"checkN('tst');\"{$checked}><label for='tst3'> Browser cookies</label><br>\n";
		echo "<br>\n";
	}
	if ($action and strpos(' create',$action)) {
		echo "<p><b>Calendar IDs / Titles:</b> (format per line: 'cal ID = cal title')</p>\n";
		echo "<textarea name='calDef'>{$newCals}</textarea><br>\n";
		echo "<table>\n";
		echo "<tr><td colspan='2'><b>Calendar:</b></td></tr>\n";
		echo "<tr><td>Email address:</td><td><input type='text' name='calEml' value='{$calEml}'></td></tr>\n";
		echo "<tr><td colspan='2'>&nbsp;</td></tr>\n";
		echo "<tr><td colspan='2'><b>Administrator:</b></td></tr>\n";
		echo "<tr><td>Name:</td><td><input type='text' name='adName' value='{$adName}'></td></tr>\n";
		echo "<tr><td>Email:</td><td><input type='text' name='adMail' value='{$adMail}'></td></tr>\n";
		echo "<tr><td>Password:</td><td><input type='text' name='adPwrd' value='{$adPwrd}'></td></tr>\n";
		echo "</table>\n";
		echo "<br>\n";
	}
	if ($action and strpos(' set',$action)) {
		echo "<p><b>Select calendar</b></p>\n";
		foreach ($calendars as $k =>$v) {
			$checked = (!empty($_POST['defCal'])) ? " checked='checked'" : ($k == $dbPfix ? " checked='checked'" : '');
			$curDef = ($k == $dbPfix) ? " <span class='mark'>(current default)</span>" : '';
			echo "<input type='checkbox' id='{$k}' name='defCal' value='{$k}' onclick=\"check1('defCal',this);\"{$checked}><label for='{$k}'> {$k} - {$v}{$curDef}</label><br>\n";
		}
		echo "<br>\n";
	}
	if ($action and strpos(' delete copy replicate backup',$action)) {
		echo '<p><b>'.(strpos(' copy replicate',$action) ? 'Select destination calendar(s)' : 'Select calendar(s)')."</b></p>\n";
		$checked = !empty($_POST['calAll']) ? " checked='checked'" : '';
		echo "<input type='checkbox' id='cal0' name='calAll' value='all' onclick=\"checkA('cal');\"{$checked}><label for='cal0'> All calendars</label><br>\n";
		foreach ($calendars as $k =>$v) {
			$checked = (!empty($_POST['cal']) and in_array($k,$_POST['cal'])) ? " checked='checked'" : '';
			$curDef = ($k == $dbPfix) ? " <span class='mark'>(default)</span>" : '';
			$disabled = ($action == 'replicate' and $k == $dbPfix) ? ' disabled' : '';
			echo "<input type='checkbox' id='cal{$k}' name='cal[]' value='{$k}' onclick=\"checkN('cal');\"{$checked}{$disabled}><label for='cal{$k}'> {$k} - {$v}{$curDef}</label><br>\n";
		}
		echo "<br>\n";
	}
	if ($action and strpos(' copy',$action)) {
		echo "<p><b>Select table(s) to copy</b></p>\n";
		$checked = !empty($_POST['tabAll']) ? " checked='checked'" : '';
		echo "<input type='checkbox' id='tab0' name='tabAll' value='all' onclick=\"checkA('tab');\"{$checked}><label for='tab0'> All tables</label><br>\n";
		foreach ($allTabs as $k =>$v) {
			$checked = (!empty($_POST['tab']) and in_array($v,$_POST['tab'])) ? " checked='checked'" : '';
			echo "<input type='checkbox' id='tab{$k}' name='tab[]' value='{$v}' onclick=\"checkN('tab');\"{$checked}><label for='tab{$k}'> {$v}</label><br>\n";
		}
		echo "<br>\n";
	}
	echo "<div class='center'>\n";
	if ($action) {
		echo "<input type='submit' id='start' name='start' onclick='return valForm()' value='".ucfirst($action)."'>\n";
		echo "<input type='submit' name='back' value='Back'>\n";
	}
	echo "</div>\n";
	echo "</form>\n";
}
?>
</div>
</div>
<div class='bLine mark'><h4>AFTER USE REMOVE THE FILE <?php echo basename(__FILE__); ?> FILE FROM THE SERVER!</h4></div>
<div class='endBar'>
	design 2014 - powered by <a href='http://www.luxsoft.eu'><span class='footLB'>Lux</span><span class='footLR'>Soft</span></a>
</div>
<br>&nbsp;
</body>
</html>
